package Shell::SSH;
use strict;
use warnings;
#use base qw( Shell );
our($VERSION, $AUTOLOAD);

$VERSION = '0.01';

# this is just needed for checking $VERSION of Shell.pm which we inherit from
# alternative: don't "use warnings;" else this modules throws "Subroutine AUTOLOAD redefined at Shell/SSH.pm line ..."
# we try to imitate "use base qw( Shell 0.4 );" which of course will never work since it "arrays" all values inside qw()
# but it also calls 'require' under the hood - rendering a "use base ('Shell 0.4');" useless, too, hmmm.....
# question: can this already be done in a more formal way?
#BEGIN { my $requires = 0.4; die "Shell version $requires required--this is only version $Shell::VERSION" if ($Shell::VERSION lt $requires); }

use Data::Dumper;
use IPC::Run qw( start pump finish timeout timer );

# debugging for IPC::Run
#$ENV{IPCRUNDEBUG} = 10;
$ENV{IPCRUNDEBUG} = 2;

local *IN;
local *OUT;
local *ERR;

my $in; my $out; my $err; my $handle;
my $t;

sub new {
  my $class = shift;
  my $self = { @_ };
  bless $self, $class;
  $self->_init();
  $self->_start();
  return $self;
}

sub DESTROY { }

sub AUTOLOAD {
  #my $self = shift if ref $_[0] && $_[0]->isa( 'Shell' );
  #my $self = shift if ref $_[0] && $_[0]->isa( 'Shell' );
  my $self = shift;
  my $cmd = $AUTOLOAD;
  $cmd =~ s/^.*:://;
  #if ($self) {
    # TODO: handle asynchronizity(?) here!
    return $self->_run_command($cmd, @_);
  #}
}

sub _init {
  my $self = shift;
  $self->{in}  = '';
  $self->{out} = '';
  $self->{err} = '';
  $in = $out = $err = '';
  $self->{method} ||= 'ssh';
}


sub _start {
  my $self = shift;

  my @cmd = ();
  die "please supply method" if (!$self->{method});
  die "please supply target" if (!$self->{target});
  
  push @cmd, $self->{method};
  push @cmd, @{$self->{args}} if ($self->{args});
  push @cmd, $self->{target} if ($self->{target});

  my $cmd = join(" ", @cmd);
  #print "command: ", $cmd, "\n";

#  $self->{handle} = start
#     \@cmd,
#        '<pipe', \*IN,
#        '>pipe', \*OUT,
#        '2>pipe', \*ERR,
#        timeout( 20 )
#     or die "could not open IPC::Run - handle: $?" ;
  #$self->{handle} = start \@cat, \$in, \$out
  #$self->{handle} = 

  #print "command: ", join(' ', @cmd), "\n";

  #$t = timeout(15);
  $t = timer(10);
  $handle = 
     start(\@cmd, \$in, \$out, \$err, $t)
     or print "NO HANDLE!!!\n";
#     or die "could not open IPC::Run - handle: $?" ;

  print "STARTUP FINISHED\n";
  #sleep 10;
  
}

sub _stop {
  my $self = shift;
  #finish $self->{handle};
  #finish $self->{handle};
  finish $handle;
}

sub _run_command {
  my $self = shift;
  my $rcommand = shift;
#print "rcmd: $rcommand\n";
  my $rargs = join(' ', @_);
  $rargs ||= '';
  my $rcommandstring = join(' ', $rcommand, $rargs);
  $rcommandstring =~ s/\s//g;
  #print "cmd: '", $rcommandstring, "'\n";
  #open IN, '';
  #$self->_read_output();
  #print IN $rcommandstring;
  #close IN;
  #pump $self->{handle};
  #$self->{in} = $rcommandstring;

  print "COMMAND SENT: $rcommandstring\n";

  $in = $rcommandstring . "\n";
  #pump $self->{handle};
  #$out = '';
  pump $handle while length $in;

  print "first pumping ready", "\n";

  #$self->_read_output();

  return '';
}

sub _read_output {
  print "_read_output\n";
  my $self = shift;
  $self->{buffer} = [];
  my $buffer = '';
  print "=read\n";

  #print Dumper($self->{handle});
  #while (<OUT>) {
  #pump $self->{handle};
  #sleep 1; pump $self->{handle};
  #sleep 1; pump $self->{handle};
  #pump $self->{handle};
  #pump $handle;

  #pump $handle while length $out;
  pump $handle;
  #pump $handle until length $out;
  #$self->{response}->($out) if $out;
  #return;

#print Dumper($self->{handle});

  # our command should just take a smaller amount of time
  my $tcmd = timer(3);

  #while (!$t->is_expired) {
  while ($out && !$tcmd->is_expired) {
    print ".\n";
    chomp($out);
    print "line: ", $out, "\n";
    $self->{response}($out) if $out;
    #push @{$self->{buffer}}, $_;
    $buffer .= $out . "\n";
    #pump $self->{handle};
    pump $handle;
  }
  print "=read okay\n";
  # TODO: async!
  #return $buffer;
  #$self->{response}->($buffer) if $buffer;
}

sub get_output {
  my $self = shift;
  return $self->{buffer};
}

sub disconnect {
  my $self = shift;
  $self->_stop();
}

1;
