#!/usr/bin/perl

# $Id$

=pod

  sshwrap - a ssh wrapper
    
    opens a secure shell connection through a http proxy by using the two fine tools ssh and corkscrew

    sshwrap utilizes some Perl modules from CPAN together with common UNIX programs to provide 
    a kind of API around the known ssh tools. It started as a standalone solution inside a single Perl script, 
    but now uses IPC::Run and Shell.pm to improve modularization and to provide convenient access and functionality.
    
    Another focus is on Linux-/Windows compatibility and - important for this special case - the possibility 
    to enter a password on the command line. (other ssh wrappers dictate to use keyfiles instead)

    It would be nice to use Net::SSH, Net::SSH::Perl or File::Remote under the hood to dispatch core 
    functions to these modules if needed through some circumstances or explicitly requested. 
    There has been done work going onto this direction, but as i see for now Net::SSH just works with keys 
    and File::Remote is stated to only work on UNIX systems.
    IPC::Run is compatible since it seems to use Win32::Process under the hood.

    Links:
      - ssh: http://openssh.org/
      - corkscrew: http://www.agroman.net/corkscrew/
      - cygwin: http://www.cygwin.com/

=cut

# cvs change history
# $Log$


use strict;
use warnings;

use Data::Dumper;
use lib '.';
#use Shell::SSH qw( echo hostname );
use Shell::SSH;

# defaults:
# - method=ssh, options=proxy_enabled=0
# - uses defaults proxy if proxy_enabled=1 and proxy_host is empty
my $command = Shell::SSH->new( 
    #method => 'ssh', 
    #method => './tester.sh',
    target => 'test@webpla.net', 
    #target => 'test@netfrag.org', 
    args => [], 
    #options => { proxy_enabled => 1, proxy_host => 'your-proxy.com:8080' } ,
    #options => { proxy_enabled => 1 } ,
    response => \&recieve_callback,
    );

# native style - deprecated  ;)
  #$command->run("cat /home/test/test.txt");
  #sub ps;
  #print ps -a;
  #print echo("abc");
  #print Dumper($output);

# sym-style
  #echo("huhu");
  #print echo("huhu");
  
# OO-style
  # TODO: return values via print "command" (Shell::SSH should block in this case)
  #print $command->hostname();
  #print $command->echo("Hello World!"), "\n";
  #print "sleeping...\n";
  #sleep 5;
  $command->hostname();
  #$command->echo("Hello World!");
  
  sub recieve_callback {
    my $output_block = shift;
    print "output: ", $output_block, "\n";
    #print $output_block;
  }

#sleep 1;

$command->_read_output();
#$command->disconnect();



print "ready.", "\n";
exit;

my $tgt1 = 5;
my $tgt2 = 10;

my $cnt = 0;
while (1) {
  print ".\n";
  sleep(1);
  if ($cnt == $tgt1) { $command->hostname(); }
  if ($cnt == $tgt2) { $command->_read_output(); }
  #$command->_read_output();
  $cnt++;
}

